#singleinstance, force
#Persistent
SetBatchLines -1
info =
(
BookCrop
version 170226
Made in Autohotkey by nod5.dcmembers.com
Free Software -- http://www.gnu.org/licenses/gpl-3.0.html
Tested in Win10 x64

WHAT IT DOES
1. Drag and drop a folder of jpeg or tif images.
2. BookCrop overlays them into one preview.
3. Draw a rectangle and click "crop" to crop all images.
(4. Ctrl+Draw another rectangle to the right to crop split to two files)

R L mode (Ctrl+Tab)
Processes *L.jpg and *R.jpg in inputfolder separately

Rotation
Press R och L at overlay preview
to rotate in 90 degree steps (applied before crop)

SETUP
- Get and install latest GraphicsMagick (Q8 version is faster)
- Get Jpegtran from libjpeg-turbo (faster than jpegclub version):
  - Download libjpeg-turbo-1.4.90-gcc.exe (64bit: gcc64.exe) or newer
  - Unzip the exe and browse \bin subfolder
  - copy jpegtran.exe + libjpeg-62.dll and place next to BookCrop.exe

NOTES
BookCrop crops all and only jpeg or tif files in the dropped folder.
Other files and subfolders are ignored.
Change threshold if overlay is too dark or light.
Drop a single jpeg/tif for quick overlay preview.
The single image preview refreshes on each threshold slider move.
Advice: Use crop to subfolder, so you can redo if you overcrop.
Preview works well only if all input images have same size.
)
xwintitle = BookCrop

Gui,6: font, s8 cgray
Gui,6: Add, Text,x290 y345 gsplash, ?
Gui,6: font, s12 bold
Gui,6: Add, GroupBox, x5 y2 w290 h300
Gui,6: Add, Text,x78 y125 h130 w200 vtxt,Drop .jpg folder
Gui,6: Show,h360 w300,%xwintitle%

checkini()
if splash = 1
 goto splash
return

;------------
checkini() {
global
xini = %A_ScriptFullPath%.ini
ifnotexist, %xini%
{
xinitext =
(
[%xwintitle%]
splash=1
subdir=1
threshold=20
)
FileAppend, %xinitext%, %xini%
}
xval = splash,threshold,subdir
Loop, Parse, xval,`,
 IniRead, %A_LoopField%, %xini%, %xwintitle%, %A_LoopField%, %A_space%
splash := splash != 0 ? 1:0
subdir := subdir != 0 ? 1:0
threshold := threshold >= 1 and threshold <= 99 ? threshold : 20
}
;------------
#IfWinActive, BookCrop ahk_class AutoHotkeyGUI
^Tab:: 
GuiControlGet,xt,6:,txt
txt := InStr(xt,"x") ? "Drop .jpg folder" : "Drop .jpg folder`nto crop R L suffixed`nimages separately"
GuiControl,6:, txt, %txt%
return

Tab:: goto splash

r:: 
l::  ;ROTATE IMAGES BEFORE CROP
GuiControlGet,btest, 5:, Button1  ;only in pic mode
if !btest 
 return
deg := a_thislabel == "r" ? 90 : -90 ;this rotation
Runwait  "%tool%" convert "%t%" -rotate %deg% "%t%" ,,hide
stemp := sh , sh := sw, sw := stemp  ;switch sizes
totrot += deg ;total rotation
totrot := totrot<0 ? totrot+360 : totrot>360 ? totrot-360 : totrot  ;0 90 170 270
x1 =
Loop, 14 ;remove all gui
  Gui, %A_Index%: destroy
makegui()
return
#IfWinActive
;------------
splash:
WinGetPos,mainx,mainy, mainw,, %xwintitle%
mainx += mainw

Gui 7:+LastFoundExist
IfWinExist
{
gui,7: destroy
return
}
Gui, 7: +ToolWindow -SysMenu -Caption -resize +AlwaysOnTop +0x800000
Gui, 7: Add, Text,, %info%
Gui, 7: Add, Text,h1, %space%
Gui, 7: Add, Checkbox,xm Checked%splash% section vsplashbox gsplashbox, show on startup
Gui, 7: Add, Checkbox,xm Checked%subdir% section vsubdirbox gsubdirbox, crop to subfolder
Gui, 7: Add, text, yp+30 x20 w55 h15,threshold
Gui, 7: Add, text, vtext yp xp+47 w20 h15,%threshold%
Gui, 7: Add, Slider, NoTicks yp+15 x11 w180 h20 vslider gslider, %threshold%
Gui, 7: Add, Link,ys xm+200,<a href="http://nod5.dcmembers.com/">nod5.dcmembers.com</a>
Gui, 7: Add, Link,yp+20 xm+200,<a href="http://sourceforge.net/projects/graphicsmagick/files/graphicsmagick-binaries/">graphicsmagick.org</a>
Gui, 7: Add, Link,yp+20 xm+200,<a href="http://sourceforge.net/projects/libjpeg-turbo/files/">libjpeg-turbo</a>
Gui, 7: show, x%mainx% y%mainy%
return
;------------
slider:
Gui, Submit, NoHide
IniWrite, %slider%, %xini%, %xwintitle%, threshold
threshold := slider
GuiControl,,text, %slider%

if xext not in single     ;not single image preview mode
 return
if tool =
 checkpaths()
if tool =
 return
RunWait "%tool%" convert -size %sw%x%sh% "%firstfile%" -sample %sw%x%sh% -threshold %threshold%`% -transparent white -flatten "%t%" ,,hide
Gui,5: destroy
makegui()
return

7GuiEscape: 
gui,7: destroy
return

splashbox: 
Gui, Submit, NoHide
IniWrite, %splashbox%, %xini%, %xwintitle%, splash
return
subdirbox:
Gui, Submit, NoHide
IniWrite, %subdirbox%, %xini%, %xwintitle%, subdir
subdir := subdirbox
return
;--------------------
checkpaths() {   
global
;search folders, since gm updates risk break registry filepath lookup
prog := StrReplace(A_ProgramFiles, " (x86)", "") ;Program Files path in any locale
Loop, Files, %prog%\GraphicsMagick* , D
 binpath := A_LoopFileFullPath
Loop, Files,  %prog% (x86)\GraphicsMagick* , D
 binpath := A_LoopFileFullPath
if !FileExist(binpath "\gm.exe")
 msgbox, Error: GraphicsMagick not found.`nInstall it and try again.
If !FileExist(A_Scriptdir "\jpegtran.exe") or !FileExist(A_Scriptdir "\libjpeg-62.dll")
 msgbox, Error: jpegtran.exe and/or libjpeg-62.dll not found.`nPlace them next to BookCrop.
If FileExist(binpath "\gm.exe") and FileExist(A_Scriptdir "\jpegtran.exe") and FileExist(A_Scriptdir "\libjpeg-62.dll")
tool = %binpath%\gm.exe
}
;--------------------
6GuiDropFiles:
5GuiDropFiles:
ar := "", al := ""
checkpaths()
if tool =
 return
xext =

Loop, parse, A_GuiEvent, `n
{
    FirstFile = %A_LoopField%
    Break
}
FileGetAttrib, xattrib, %firstfile%
SplitPath, firstfile,,xdir,xext
if xattrib not contains D           ;no directory
 if xext not in jpg,tif             ;no jpg or tif
  return                            

if xattrib contains D
 xdir = %firstfile%
t = %xdir%\%A_scriptname%_over.png
filedelete %t%

Gui,5: destroy
Gui,6: destroy
Gui,7: destroy

;GET IMAGE DIMENSIONS
getdim(xdimfile) {
global
Img := ComObjCreate("WIA.ImageFile")
Img.LoadFile(xdimfile)
imgw := Img.Width , imgh := Img.Height
sh := A_ScreenHeight-130  ;try fit pic to screen height
prop :=  sh/imgh 		      ;Exact proportion pic/source height, for later upscale
sw := imgw*prop
swmax := A_ScreenWidth-100	
if sw > swmax		;if too wide then fit screen width
 sw := A_ScreenWidth-100, prop := sw/imgw, sh := imgh*prop
sh := Round(sh), sw := Round(sw)
}

if xext in jpg,tif   ;prepare single image preview mode
{
getdim(firstfile)
RunWait "%tool%" convert -size %sw%x%sh% "%firstfile%" -sample %sw%x%sh% -threshold %threshold%`% -transparent white -flatten "%t%" ,,hide
xext = single
makegui()
return
}

at := Object() , aj := Object()  ;tiff or jpg array
Loop, %xdir%\*.jpg		;prepare multi image overlay
 aj.Insert(A_LoopFileFullpath)
Loop, %xdir%\*.tif		
 at.Insert(A_LoopFileFullpath)
if (aj.MaxIndex() == 0 and at.MaxIndex() == 0)
 return
xext := aj.MaxIndex() >= at.MaxIndex() ? "jpg" : "tif" ;DO MOST COMMON FILETYPE
ado := aj.MaxIndex() >= at.MaxIndex() ? aj : at

ar := Object() , al := Object()
if InStr(txt,"x") ;do R L files separately
	{
	for key, val in ado
		{
		if SubStr(val,-4) == "R." xext
		 ar.Insert(val)
		else if SubStr(val,-4) == "L." xext
		 al.Insert(val)
		}

	if ar.MaxIndex() == 0 or al.MaxIndex() == 0 ;R or L array empty
	 return
	ado := al  ;do L array first
	}

rightside:
getdim(ado[1])	;get first file dimensions
xcount := ado.MAxIndex() ;number of images in batch

SetTimer, prog, 200
Progress, 0,, Creating overlay,%xwintitle%
;binarize with transparent white, mpc format is faster than jpg
;run many jobs to utilize cpu cores

tick := A_TickCount
for key, val in ado
{
Run "%tool%" convert -size %sw%x%sh% "%val%" -sample %sw%x%sh% -threshold %threshold%`% -transparent white "%val%_%A_scriptname%_temp.mpc" ,,hide
sleep 10
}

loop 30
{
process, exist, gm.exe   ;wait until all jobs end
if errorlevel = 0
 break
sleep 100
}
;flatten all into overlay image; very fast, no need to optimize
Runwait  "%tool%" convert "%xdir%\*_%A_scriptname%_temp.mpc" -flatten "%t%" ,,hide
filedelete, %xdir%\*_%A_scriptname%_temp.mpc
filedelete, %xdir%\*_%A_scriptname%_temp.cache
tick := A_TickCount - tick
SetTimer, prog, Off
progress, off
makegui()
;msgbox overlay time = %tick% ms ;speedtest
return

makegui() {
global
Gui,5: destroy
Gui,6: destroy
sh := sh < 50 ? A_screenheight-100 : sh
sw := sw < 50 ? A_screenwidth : sw

Gui,5: margin,0,0
Gui,5: font, s12 bold
hbut := sh+5, htot := sh+40, xspl := sw-10
Gui,5: Add, Button, x100 y%hbut% vcrop gcrop, Crop
GuiControl,5: Disable, crop
Gui,5: font, s8 cgray norm
Gui,5: Show,w%sw% h%htot%,%xwintitle%
Gui,5: Add, Text,x%xspl% yp+10 gsplash, ?
Gui,5: +LastFound
MainhWnd := WinExist()

Gui, 6: margin,0,0									;image child window
Gui, 6: Add, Pic, vpic gpic, %t%		
Gui, 6: +Owner -Caption -SysMenu -resize +ToolWindow +0x800000 
Gui, 6: Show, x0 y0
Gui, 6: +LastFound
pichWnd := WinExist()
Gui, 6: +Parent%MainhWnd%
}
;--------------------
prog:   ;progress timer
Loop, %xdir%\*.mpc
 xcountpng := a_index
prog := ( xcountpng / xcount ) * 100
progress, %prog%
return
;--------------------
pic:
if xext in single
 return
xcontr := GetKeyState("Control") == 1 and x1 != "" ? 1 : "" ;if control and selection1
WinGetPos, xwin, ywin,wwin,hwin, %xwintitle%     ;main gui screen pos            
WinGetPos, px,py,pw,ph, ahk_id %pichWnd%				 ;pic screen pos
x1abs := px 		      ;pic left edge screen pos 
y1abs := py 					;pic top 
x2abs := px + pw 			;pic right
y2abs := py + ph 			;pic low

LetUserSelectRect(tempx1, tempy1, tempx2, tempy2)

if (tempx1 == tempx2 OR tempy1 == tempy2)	;no rect or aborted
{
 Loop, 4
  Gui, %xcontr%%A_Index%: destroy
 return
}

tempx1 -= x1abs , tempy1 -= y1abs   ;pos rel to pic top left x y
tempx2 -= x1abs , tempy2 -= y1abs

if (xcontr=="1") 
 if (tempx1>=x1 and tempx1<=x2) or (tempx2>=x1 and tempx2<=x2) or (tempx1<x1 and tempx2>x2)
{
Loop, 4
	Gui, %xcontr%%A_Index%: destroy		;abort if selection2 overlaps selection1
return
}

if (xcontr=="1") 
 lx1:=tempx1, lx2:=tempx2, ly1:=tempy1, ly2:=tempy2, r:=2
else
 x1:=tempx1, x2:=tempx2, y1:=tempy1, y2:=tempy2,r:=2, lx1:="",ly1:="",lx2:="",ly2:=""

;set x y relative to parent
Gui, %xcontr%1:Show, % "NA X" tempx1 " Y" tempy1 " W" tempx2-tempx1 " H" r
Gui, %xcontr%2:Show, % "NA X" tempx1 " Y" tempy2-r " W" tempx2-tempx1 " H" r
Gui, %xcontr%3:Show, % "NA X" tempx1 " Y" tempy1 " W" r " H" tempy2-tempy1
Gui, %xcontr%4:Show, % "NA X" tempx2-r " Y" tempy1 " W" r " H" tempy2-tempy1

GuiControl,5: Enable, crop
ControlFocus, Button1, ahk_id %MainhWnd% ;removes focus from rect
return

;------------
crop:
if x1 =   ;no selection
 return
tick := A_TickCount
;make crop values
x :=round(x1/prop) , y :=round(y1/prop), w :=round( (x2-x1)/prop ) , h :=round( (y2-y1)/prop )
if lx1 !=   ;selection2
 lx :=Round(lx1/prop), ly :=Round(ly1/prop), lw :=Round( (lx2-lx1)/prop ), lh :=Round( (ly2-ly1)/prop )

if lx != ;crop two images
 xcount *= 2
Progress, 0,, Cropping,,
settimer, progout, 600

xtimestart := A_now
if (ado != ar) ;if ar then reuse xdir2 set in al array crop
 xdir2 := xdir
if (subdir == 1)
{
if (ado != ar) 
xdir2 = %xdir%\%xtimestart%
FileCreateDir, %xdir2%
}

cropper := xext == "tif" ? tool : A_scriptdir "\jpegtran.exe"
rot := totrot > 0 ? "-rotate " totrot : "" 	
for key,val in ado
{
SplitPath, val,xname,,,xnoext    ;right crop
	if (xext == "tif")
	{
	if lx   ;split crop right side
	 Run "%cropper%" convert %rot% -crop %LW%x%LH%+%LX%+%LY% "%val%" "%xdir2%\%xnoext%_R.%xext%",,hide
	Run "%cropper%" convert %rot% -crop %W%x%H%+%X%+%Y% "%val%" "%xdir2%\%xname%" ,,hide
	}
	else   ;jpg
	{
	if lx  ;split crop right side
	 Run "%cropper%" %rot% -crop %LW%x%LH%+%LX%+%LY% -outfile "%xdir2%\%xnoext%_R.%xext%" "%val%",,hide
	Run "%cropper%" %rot% -crop %W%x%H%+%X%+%Y% -outfile "%xdir2%\%xname%" "%val%",,hide
	}
sleep 10
}

SplitPath, cropper, cropper	;jpegtran.exe or gm.exe
loop
{
Process, Exist, %cropper%
if (errorlevel == 0)
 break
}
settimer, progout, off
progress, off
sleep 300
FileDelete, %t%

if (ado == al) ;left images now cropped, do right
{
ado := ar, totrot := ""
Gui,5: destroy
Gui,6: destroy
Gui,7: destroy
goto rightside
}
tick := A_TickCount - tick
;msgbox crop time = %tick% ms   ;speedtest
reload
return
;--------------------
progout:      ;progress bar for crop
xtot = 0
Loop, %xdir2%\*.%xext%
{
FileGetTime, xtime, %A_LoopFileFullPath%      ;get last mod time
if ( xtime > xtimestart )
 xtot += 1
}
prog := ( xtot / xcount ) * 100
progress, %prog%
return

6GuiClose:
5GuiClose:
FileDelete, %t%
ExitApp

; modification of LetUserSelectRect function by Lexikos
; www.autohotkey.com/community/viewtopic.php?t=49784

LetUserSelectRect(ByRef X1, ByRef Y1, ByRef X2, ByRef Y2)
{
		global x1abs, y1abs, x2abs, y2abs, MainhWnd, xcontr
		CoordMode, Mouse, Screen  
    static r := 2
    Loop 4 {
        if !xcontr	;clear sel2 if new sel1
         Gui, 1%A_Index%: destroy
        Gui, %xcontr%%A_Index%: destroy  ;clear same type sel
        Gui, %xcontr%%A_Index%: -Caption +ToolWindow +AlwaysOnTop
        Gui, %xcontr%%A_Index%: Color, Red
        if !xcontr
         GuiControl,5: Disable, crop
    }
    GetKeyState, xbut, LButton, P
    if xbut = U
     return    
 
    MouseGetPos, xo, yo 			;first click position
    SetTimer, lusr_update, 10			;selection rectangle update timer 
    KeyWait, LButton								;wait for LButton release
    SetTimer, lusr_update, Off
    Loop 4													;make child
     Gui, %xcontr%%A_Index%: +Parent%MainhWnd%
    return
 
    lusr_update:
		CoordMode, Mouse, Screen
		MouseGetPos, x, y
		y1 := y<yo ? y:yo , y2 := y<yo ? yo:y    ;rename x1/x2 y1/y2 if negative rect draw
		x1 := x<xo ? x:xo , x2 := x<xo ? xo:x
		x1 := x1 < x1abs ? x1abs:x1 , x2 := x2>x2abs ? x2abs:x2 ;stop at pic edges
		y1 := y1 < y1abs ? y1abs:y1 , y2 := y2>y2abs ? y2abs:y2

		; Update the "selection rectangle" ;gui 1 2 3 4 or 11 12 13 14
		Gui, %xcontr%1:Show, % "NA X" x1 " Y" y1 " W" x2-x1 " H" r
		Gui, %xcontr%2:Show, % "NA X" x1 " Y" y2-r " W" x2-x1 " H" r
		Gui, %xcontr%3:Show, % "NA X" x1 " Y" y1 " W" r " H" y2-y1
		Gui, %xcontr%4:Show, % "NA X" x2-r " Y" y1 " W" r " H" y2-y1
		return
}
